/*
 *  MemoryRecorder.cpp
 *  _crono3
 *
 *  Created by trollback on 4/12/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#include "cursor.h"

//--------------------------------------------------------------
void CursorPoint::init() {
    
    idle_thresh = 60;
    idle_count = 0;
    alpha = 0;
    is_showing = false;
    Tweenzor::init();

}

//--------------------------------------------------------------
void CursorPoint::setPosition(int x, int y) {
    
    xpos = x;
    ypos = y;
    
    if((xpos == prev_x)&&(ypos == prev_y)){
        idle_count++;
        if((idle_count > idle_thresh)&&(is_showing)){
            hide();
        }
    } else {
        if((!is_showing)){
            idle_count = 0;
            show();
        }
    }
    
    prev_x = xpos;
    prev_y = ypos;

}

//--------------------------------------------------------------
void CursorPoint::draw() {
 
    ofSetColor(23,193,225,alpha*255);
    ofNoFill();  
    ofSetLineWidth(2);  
    ofCircle(xpos, ypos, 10);
    ofSetLineWidth(0);
    ofFill();
    ofSetColor(23,193,225,255);

}

//--------------------------------------------------------------
void CursorPoint::update() {
    Tweenzor::update();

}

//--------------------------------------------------------------
void CursorPoint::show() {
    //alpha = 1.0;
    alpha_anim = 1.0;
    Tweenzor::add( &alpha, alpha, alpha_anim, 0.0f, .1f, EASE_OUT_SINE);
    is_showing = true;
}

//--------------------------------------------------------------
void CursorPoint::hide() {
    //alpha = 0;
    alpha_anim = 0.0;
    Tweenzor::add( &alpha, alpha, alpha_anim, 0.0f, .5f, EASE_OUT_SINE);
    is_showing = false;
}



