/*
 *  MemoryRecorder.cpp
 *  _crono3
 *
 *  Created by trollback on 4/12/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#include "memoryRecorder.h"

void MemoryRecorder::init(int x, int y, int w,int h) {
	
	
	xpos = (float)x;
	ypos = (float)y;
	width = w;
	height = h;
	isRecording = false;
	currentframe = 0;
			
	bufferThreshold = 5;
	
	framestep    = 3;
	framerest    = 2;
	framecounter = 0;
	
    //px = new unsigned char[width*height*3];
    px = new unsigned char [width*height*3];
    
    max_frames = 300;
    
}

void MemoryRecorder::drawInfo(ofTrueTypeFont * font){
	ofSetColor(255);
	string cnt = "r: " + ofToString(row, 0) + " c: " + ofToString(column, 0);
    font->drawString(cnt, xpos, ypos+20);  
}  

void MemoryRecorder::setSize(int w, int h) {
	width = w;
	height = h;
    //px = new unsigned char[width*height*3];

}

void MemoryRecorder::setPosition(int x, int y, bool animate) {
	
	if(x < 0) x = 0;
	if(y < 0) y = 0;

	if(animate){
				
		new_x = (float)x;
		new_y = (float)y;	

	} else {
			
		xpos = (float)x;
		ypos = (float)y;
		
	}
		
	
}

void MemoryRecorder::setFromPixels( unsigned char* _pixels, int w, int h ) {
   
    
    cout << "adding the mem recorder" << endl;
    
    unsigned char* px = new unsigned char [w*h*1];
    
    memcpy(px, _pixels, w*h*1);
	imageList.push_back(px);
    
    if(imageList.size() > max_frames){
        delete imageList[0];
        imageList.erase(imageList.begin());
    }
     
}


void MemoryRecorder::onCompleteX(float args) {
	xpos = new_x;
	cout << "complete x" << endl;
}

void MemoryRecorder::onCompleteY(float args) {
	ypos = new_y;
	cout << "complete y" << endl;
}

void MemoryRecorder::draw() {

    if(imageList.size() > 0){
        //cout << " draw width " << currentframe << endl;
        ofSetColor(255, 255, 255, 255);

       // unsigned char* p = new unsigned char[width*height*3];
        
       // memcpy(p, imageList[currentframe], width*height*3);
        img.setFromPixels(imageList[currentframe], width, height, OF_IMAGE_GRAYSCALE);
        img.draw(0, 0, width, height);
    }
}

void MemoryRecorder::setOffset(int n){
	currentframe = n % imageList.size()-1;
}

void MemoryRecorder::record(){
	isRecording = true;
    currentframe = 0;
	clear();
	
}

void MemoryRecorder::play(){	
	//isRecording = false;
    currentframe = 0;
}

int MemoryRecorder::getHeight(){
	return height;
}

int MemoryRecorder::getWidth(){
	return width;
}


int MemoryRecorder::getColumn(){
	return column;
}

int MemoryRecorder::getRow(){
	return row;
}

void MemoryRecorder::setColumn(int n){
	column = n;
}

void MemoryRecorder::setRow(int n){
	row = n;
}

int MemoryRecorder::getXpos(){
	return xpos;
}

int MemoryRecorder::getYpos(){
	return ypos;
}

//--------------------------------------------------------------
void MemoryRecorder::update() {
	
    currentframe++;
	
    if((isRecording)&&(currentframe >= max_frames-1)){
        isRecording = false;
    }
    
    if(currentframe >= imageList.size())currentframe = 0;
    
}

unsigned char* MemoryRecorder::getFrame(){
    cout << " returning " << currentframe << endl;
	return imageList[currentframe];
}

unsigned char* MemoryRecorder::getFrame(int f){
    cout << " returning this frame " << f << endl;
	return imageList[f];
}


int MemoryRecorder::getNumFrames(){
    return imageList.size();
}

//--------------------------------------------------------------
void MemoryRecorder::clear() {
	
	
	//inited = false;
	
	cout << "CLEAR  MEMORY RECORDER " << getWidth() << " " << getHeight() << endl;
	
    
    for (int i = 0; i<imageList.size(); i++) {
       // imageList[i].
        //free(imageList[i]);
        //imageList[i] = NULL;
        delete imageList[i]; 
        
    } 
    imageList.resize(0);
    //delete imageList;
	
	//image.setFromPixels(pixels, getWidth(), getHeight(), OF_IMAGE_COLOR);
	
}