/*
 *  photo.cpp
 *  iPhoneVidGrabberExample
 *
 *  Created by trollback on 4/4/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */


#include "photo.h"

void Photo::init(int w,int h) {
	width = w;
	height = h;
	inited = false;
	image.allocate(w, h, OF_IMAGE_COLOR);
	
	/*
     int len = (width*height*3);
     
     unsigned char initpixels[len];
     
     //int lennew = sizeof(_pixels);
     for (int i = 0; i < (len); i++) {
     initpixels[i] = 200;
     }
     
     image.setFromPixels(initpixels, width, height, OF_IMAGE_COLOR_ALPHA);
	 */
	
}

void Photo::setSize(int w, int h) {
	//alpha = 255.f;
	image.resize(w,h);
}

void Photo::setBlur(int b, int br){
	blur = b*.01;
	blurreverse = br*.01;
}

void Photo::setBlendMode(int b){
	
	cout << "blend mode = " << b << endl;
	
	blendModeInt = b;
}

void Photo::addPixels_lighten(unsigned char* _pixels, int w, int h){
	
	
	if(inited){
		
		unsigned char * currentpixels = image.getPixels(); 
		
		int len = (w*h*4);
		
		//int lennew = sizeof(_pixels);
		for (int i = 0; i < (len); i++) {	
			
			switch (blendModeInt){
					
				case 0:
					_pixels[i] = blend_lighten(_pixels[i], currentpixels[i]);
					break;
				case 1:
					_pixels[i] = blend_darken(_pixels[i], currentpixels[i]);
					break;						
				case 2:
					_pixels[i] = blend_screen(_pixels[i], currentpixels[i]);
					break;	
				case 3:
					_pixels[i] = blend_soft_light(_pixels[i], currentpixels[i]);
					break;	
				case 4:
					_pixels[i] = blend_overlay(_pixels[i], currentpixels[i]);
					break;	
				case 5:
					_pixels[i] = blend_multiply(_pixels[i], currentpixels[i]);
					break;						
			}
			
		}
		
		
		
		
		
	} else {
		inited = true;
	}
	
	cout << "_pixel[1000] = " << _pixels[1000] << " _pixel[2000] = " << _pixels[2000] << endl;
	image.setFromPixels(_pixels, w, h, OF_IMAGE_COLOR_ALPHA);
	
}

void Photo::previewImage(unsigned char* currentpixels, unsigned char* _pixels, int w, int h){
	
	//cout << "current px = " << currentpixels[2000] << endl;
	
	if(inited){
		
		int len = (w*h*4);
		
		for (int i = 0; i < (len); i++) {	
			
			switch (blendModeInt){
					
				case 0:
					_pixels[i] = blend_lighten(_pixels[i], currentpixels[i]);
					break;
				case 1:
					_pixels[i] = blend_darken(_pixels[i], currentpixels[i]);
					break;						
				case 2:
					_pixels[i] = blend_screen(_pixels[i], currentpixels[i]);
					break;	
				case 3:
					_pixels[i] = blend_soft_light(_pixels[i], currentpixels[i]);
					break;	
				case 4:
					_pixels[i] = blend_overlay(_pixels[i], currentpixels[i]);
					break;
				case 5:
					_pixels[i] = blend_multiply(_pixels[i], currentpixels[i]);
					break;					
			}
			
		}
		
	} else {
		
		inited = true;
		
	}
	
	image.setFromPixels(_pixels, w, h, OF_IMAGE_COLOR);
	
}

void Photo::setFromPixels( unsigned char* _pixels, int w, int h ) {
	
	//magic
	/*
	 
	 if(inited){
	 
	 
	 
	 unsigned char * currentpixels = image.getPixels(); 
	 
	 int len = (w*h*3);
	 width = w;
	 height = h;
	 
	 //int lennew = sizeof(_pixels);
	 for (int i = 0; i <= (len); i++) {
	 
	 
	 
	 _pixels[i] = _pixels[i] *(1-blur) + currentpixels[i] *blur;
	 //_pixels[i] = _pixels[i] *blurreverse + currentpixels[i] *blur;
	 }
	 
	 
	 
	 } else {
	 inited = true;
	 
	 }
	 */
	//cout << "_pixel[1000] = " << _pixels[1000] << " _pixel[2000] = " << _pixels[2000] << endl;
	image.setFromPixels(_pixels, w, h, OF_IMAGE_COLOR, true);
}

void Photo::fadeTo(float startAlpha, float endAlpha) {
	//cout << "fadeTo Start = " << startAlpha << endl;
	// we must pass in a standard begin if we want to get the same value of 550.f, since _x1 does not finish, since it is paused //
}

void Photo::fadeComplete(float args) {
	//cout << "Photo::onComplete args = " << args << endl;
}

void Photo::draw(int xpos, int ypos) {
	ofSetColor(255,255,255);
	image.draw(xpos, ypos);
}

void Photo::resize(int w, int h) {
	image.resize(w, h);
}

void Photo::grabScreen(int x, int y){
	image.grabScreen(x, y, image.getWidth(), image.getHeight());
}

void Photo::loadImage(string filename){
	image.loadImage(filename);
}

void Photo::saveImage(string filename){
	image.saveImage(filename);
}

int Photo::blend_lighten(int a, int b) {
	return (a > b) ? a:b;
}

int Photo::blend_darken(int a, int b) {
	return (a > b) ? b:a;
}


int Photo::blend_screen(int B, int L) {
	return (255 - (((255 - B) * (255 - L)) >> 8));
}

int Photo::blend_soft_light(int B, int L){
	return ((int)((L < 128)?(2*((B>>1)+64))*((float)L/255):(255-(2*(255-((B>>1)+64))*(float)(255-L)/255))));
}

int Photo::blend_overlay(int B, int L){
	return ((int)((L < 128) ? (2 * B * L / 255):(255 - 2 * (255 - B) * (255 - L) / 255)));
}

int Photo::blend_multiply(int B, int L){
	return (int)((B * L) / 255);
}

unsigned char* Photo::getPixels(){
	return image.getPixels();
}

int Photo::getHeight(){
	return image.getHeight();
}

int Photo::getWidth(){
	return image.getWidth();
}

//--------------------------------------------------------------
void Photo::update() {
	//Tweenzor::update();
}

//--------------------------------------------------------------
void Photo::clear() {
	
	
	inited = false;
	
	cout << "CLEAR " << getWidth() << " " << getHeight() << endl;
	
	//unsigned char * currentpixels = image.getPixels(); 
	unsigned char * pixels = new unsigned char[getWidth()*getHeight()*3];
	
	int len = (getWidth()*getHeight()*3);
	
	//int lennew = sizeof(_pixels);
	for (int i = 0; i < (len); i++) {
		pixels[i] = 0;
	}
	
	image.setFromPixels(pixels, getWidth(), getHeight(), OF_IMAGE_COLOR);
	
}