/*
 *  photoRecorder.cpp
 *  _crono3
 *
 *  Created by trollback on 4/12/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#include "photoRecorder.h"

//int colors [] = { 0x00ace6, 0xebad1e, 0xb283b9, 0xba1341 };
//int colors [] = { 0xdfe84d, 0xffe24a, 0x92ff5d, 0x64e883, 0x63ffd5 };
int colors [] = { 0x616265, 0x36424a, 0x685c53, 0x4d4e53, 0x3d3524 };

void PhotoRecorder::init(int x, int y, int w,int h) {
	
	Tweenzor::init();
	
	xpos = (float)x;
	ypos = (float)y;
	width = w;
	height = h;
	isRecording = false;
	currentframe = 0;
    
	bufferThreshold = 20;
	
	framestep    = 3;
	framerest    = 2;
	framecounter = 0;
    
    doTraceContours = true;
    
    colorLayer.init();
    
    colorItr = 0;
    
    border_width = 10;
	threshold = 80;
	//grayDiff.allocate(width,height);
    
    max_frames = 300;
    
    showColor = true;
    
    brt = .55;
    cnt = .75;
	_alpha = 1;
    
    colorOffset = 6;
    
    fbo_a.allocate(width, height, GL_RGB);
	fbo_b.allocate(width, height, GL_RGB);
	fbo_c.allocate(width, height, GL_RGB);
	
    
    /*
    ofFbo::Settings settings;
    settings.width = width;
    settings.height = width;
    settings.internalformat = GL_RGBA;
    settings.numSamples = 0;
    settings.useDepth = false;
    settings.useStencil = false;
    fbo_a.allocate(settings);
    fbo_b.allocate(settings);
    fbo_c.allocate(settings);
    
    glActiveTexture(GL_TEXTURE0);    
    fbo_a.getTextureReference().bind();
    fbo_b.getTextureReference().bind();
    fbo_c.getTextureReference().bind();
    */
}

void PhotoRecorder::setColorMode(int c){
    if(c == 1){
        showColor = true;
    } else {
        showColor = false;
    }
}

void PhotoRecorder::drawInfo(ofTrueTypeFont * font){
    ofSetColor(255);//116
	string cnt = "r: " + ofToString(row, 0) + " c: " + ofToString(column, 0);
    font->drawString(cnt, xpos, ypos+20);  
}  

void PhotoRecorder::setSize(int w, int h) {
	width = w;
	height = h;
    
    fbo_a.allocate(width, height, GL_RGB);
	fbo_b.allocate(width, height, GL_RGB);
    fbo_c.allocate(width, height, GL_RGB);
    
    //grayDiff.resize(width, height);
}

void PhotoRecorder::setPosition(int x, int y, bool animate) {
	
	if(x < 0) x = 0;
	if(y < 0) y = 0;
    
	if(animate){
        
		new_x = (float)x;
		new_y = (float)y;	
		
		Tweenzor::add( &xpos, xpos, new_x, ofRandom(0.0f, 0.0f), ofRandom(0.f, .15f), EASE_IN_SINE);
		Tweenzor::getRecentTween()->addListener( Tween::COMPLETE, this, &PhotoRecorder::onCompleteX);
        
		Tweenzor::add( &ypos, ypos, new_y, ofRandom(0.0f, 0.0f), ofRandom(0.f, .15f), EASE_OUT_SINE );
		Tweenzor::getRecentTween()->addListener( Tween::COMPLETE, this, &PhotoRecorder::onCompleteY);
        
	} else {
        
		xpos = (float)x;
		ypos = (float)y;
		
        _alpha = 0.0;
        //_alpha = 0.0;
        float alpha_anim = 1.0;

        Tweenzor::add( &_alpha, _alpha, alpha_anim, ofRandom(0.05f, 0.75f), .5f, EASE_OUT_SINE);
        
        //Tweenzor::add( &_alpha, 0, 1, ofRandom(0.5f, 0.75f), ofRandom(0.f, 2.55f), EASE_OUT_SINE );
	}
    
	
}

void PhotoRecorder::fadeIn(){
    _alpha = 0.0;
    //_alpha = 0.0;
    float alpha_anim = 1.0;

    Tweenzor::add( &_alpha, _alpha, alpha_anim, ofRandom(0.05f, 0.75f), .5f, EASE_OUT_SINE);
}

void PhotoRecorder::setFromPixels( unsigned char* _pixels, int w, int h ) {
	
    unsigned char* px = new unsigned char [w*h*1];
    memcpy(px, _pixels, w*h*1);
	imageList.push_back(px);
    
    if(imageList.size() > max_frames){
        delete imageList[0];
        imageList.erase(imageList.begin());
    }
    
}


void PhotoRecorder::onCompleteX(float args) {
	xpos = new_x;
	cout << "complete x" << endl;
}

void PhotoRecorder::onCompleteY(float args) {
	ypos = new_y;
	cout << "complete y" << endl;
}


void PhotoRecorder::draw() {
    
	if(isRecording){
        
        ofSetColor(255,255,255,255);//116

        if(imageList.size() > 0){

            img.setFromPixels(imageList[imageList.size()-1], width, height, OF_IMAGE_GRAYSCALE);
            img.draw(xpos, ypos, width, height);

        } 	
        
        ofRect(xpos, ypos, width, border_width);
        ofRect(xpos, ypos+height-border_width, width, border_width);
        ofRect(xpos, ypos+border_width, border_width, height-border_width*2);
        ofRect(xpos+width-border_width, ypos+border_width, border_width, height-border_width*2);

    } else {
        
        ofEnableAlphaBlending();
        
        int alp = _alpha*255.0f;
        
        //cout << "alpha to " << alp << endl;
        
        //ofSetColor(255,255,255,alp);//116
		if(imageList.size() > bufferThreshold){
            
            int cf = currentframe - colorOffset; 
            
            if(cf < 0){
                cf += imageList.size() - 1;
            }
            
            
            int bf = currentframe - 10; 
            
            if(bf < 0){
                bf += imageList.size() - 1;
            }
            
            
                    
            fbo_a.begin();
            
            
            ofSetColor(255,255,255,255);//116

            c_img.setFromPixels(imageList[cf], width, height, OF_IMAGE_GRAYSCALE);
            c_img.draw(0, 0, width, height);

            glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);  
            glEnable(GL_LINE_SMOOTH);  
            glEnable(GL_ALPHA);
            glEnable(GL_BLEND);  
            glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); // screen

            
            //ofSetHexColor(0xb81c4c);
            ofSetHexColor(0xc537b7);


            ofRect(0, 0, width, height);
            
            glDisable(GL_BLEND);            

            fbo_a.end();
        
             

            
            ////
            
            fbo_b.begin();

            
            ofSetColor(255,255,255,255);//116
            
            b_img.setFromPixels(imageList[bf], width, height, OF_IMAGE_GRAYSCALE);
            b_img.draw(0, 0, width, height);
            
            
            //glBlendFunc(GL_DST_COLOR, GL_ZERO); // multiply  

            
            glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);  
            glEnable(GL_LINE_SMOOTH);  
            glEnable(GL_ALPHA);
            glEnable(GL_BLEND);  
            glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); // screen
            
            
            //ofSetHexColor(0xe0aa1f);
            ofSetHexColor(0xffd832);

            
            ofRect(0, 0, width, height);

            glDisable(GL_BLEND);

            fbo_b.end();
            
            
            
            ///
            fbo_c.begin();
            //fbo_c.setAnchorPoint(xpos, ypos);

            
            ofSetColor(255,255,255,255);//116
            //ofSetHexColor(0x379ad2);

            img.setFromPixels(imageList[currentframe], width, height, OF_IMAGE_GRAYSCALE);
            img.draw(0, 0, width, height);

            glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);  
            glEnable(GL_LINE_SMOOTH);  
            glEnable(GL_ALPHA);
            glEnable(GL_BLEND);  
            glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); // screen
            
            //ofSetHexColor(0x379ad2);
            ofSetHexColor(0x27a7df);
            
            ofRect(0, 0, width, height);
            
            glDisable(GL_BLEND);
            
            fbo_c.end();

            /*
            fbo_a.draw(xpos, ypos, width, height);
             //
            */
            ofSetColor(255,255,255,255*_alpha);//116

           // fbo_b.draw(xpos, ypos, 512, 512);

            //fbo_c.draw(xpos, ypos);
            
            //
            
            
            glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);  
            glEnable(GL_LINE_SMOOTH);  
            glEnable(GL_ALPHA);
            glEnable(GL_BLEND);
            glBlendFunc(GL_DST_COLOR, GL_ZERO); // multiply  
            //glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); // screen

            ofPixels pixels_a;
            fbo_a.readToPixels(pixels_a);            
            c_img.setFromPixels(pixels_a.getPixels(), width, height, OF_IMAGE_COLOR);
            c_img.draw(xpos, ypos, width, height);
            
            ofPixels pixels_b;
            fbo_b.readToPixels(pixels_b);            
            b_img.setFromPixels(pixels_b.getPixels(), width, height, OF_IMAGE_COLOR);
            b_img.draw(xpos, ypos, width, height);
            
            ofPixels pixels;
            fbo_c.readToPixels(pixels);            
            img.setFromPixels(pixels.getPixels(), width, height, OF_IMAGE_COLOR);
            img.draw(xpos, ypos, width, height);
            
            
            glDisable(GL_BLEND);
            //glPopMatrix();
            
		} else if (imageList.size() > 0){
            img.setFromPixels(imageList[imageList.size()-1], width, height, 
                              OF_IMAGE_GRAYSCALE);
            
            img.draw(xpos, ypos, width, height);
		} else {
            //ofSetColor(255,255,255, _alpha*255.0f);//116
            ofRect(xpos, ypos, width, height);
            //ofSetColor(255,255,255, 100);
        }
        
        
        
        
        
        
        
    }
    
    if(getNumFrames() > 10){
        
        //
        
        /*
        
         */
        //
       /*
        if(doTraceContours){
            
             grayDiff.setFromPixels(imageList[currentframe], width,height);
             grayDiff.threshold(threshold);
            grayDiff.invert();
            //grayDiff.draw(xpos, ypos);
            
             contourFinder.findContours(grayDiff, width*height*.05, (width*height*3), 1, true);
             //contourFinder.draw(xpos,ypos);
            

            for (int i = 0; i < contourFinder.nBlobs; i++){
                contourFinder.blobs[i].draw(xpos,ypos);
            }
                
   
        }
        */
    
    }
  /*
    if(showColor == true){
    ofEnableAlphaBlending();
    glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);  
    glEnable(GL_LINE_SMOOTH);  
    glEnable(GL_ALPHA);
    glEnable(GL_BLEND);  
    ofSetColor(255,255,255,_alpha*255);//116
    glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR); // screen
    
    glPushMatrix();
    
    ofFill();
    //ofSetHexColor(colors[colorItr]);
    
    colorLayer.draw(xpos, ypos, width, height);
    
    
    glPopMatrix();
    
    glDisable(GL_BLEND);  
    
    ofSetColor(255,255,255, _alpha*255);//116
    }
   */
}

void PhotoRecorder::setCurrentFrame(int n){
    if(imageList.size() > 0){
        currentframe = n % imageList.size()-1;
    }
}

void PhotoRecorder::setOffset(int n){
    
    cout << "OFFSET N = " << n << endl;
    
    if(imageList.size() > 0){
        currentframe = (currentframe + n) % imageList.size();
        
    } else {
        currentframe = (currentframe + n);
        if(currentframe >= imageList.size())currentframe = 0;
        
    }
    
    //currentframe += n % imageList.size()-1;
    
    //cout << "offset " << currentframe << endl;
}

void PhotoRecorder::record(){
	
	isRecording = true;
    // currentframe = 0;
	//clear();
	
}

bool PhotoRecorder::checkIsRecording(){
    return isRecording;
}

void PhotoRecorder::play(){	
    //currentframe = 0;
	isRecording = false;
}

int PhotoRecorder::getHeight(){
	return height;
}

int PhotoRecorder::getWidth(){
	return width;
}


int PhotoRecorder::getColumn(){
	return column;
}

int PhotoRecorder::getRow(){
	return row;
}

void PhotoRecorder::setColumn(int n){
	column = n;
}

void PhotoRecorder::setRow(int n){
	row = n;
}

void PhotoRecorder::shuffle(){
    
    int block = 3;
    vector <unsigned char*> tempList;// = new unsigned* char [width*height*3];; 
    
    vector <int> positionsList;
    
    int len = imageList.size();
    int mod = floor(len/block);
    
    for(int i = 0; i<mod; i++){
        positionsList.push_back(i);
    }
    random_shuffle(positionsList.begin(), positionsList.end());
    
    for(int j = 0; j<positionsList.size(); j++){
        int curr = positionsList[j];
        
        
        
        for(int k = (curr*block); k<(curr*block)+block; k++){
            
            cout << "k " << k << endl;
            
            if(k < imageList.size()){
                tempList.push_back(imageList[k]);
            }
        }
        
    }
    
    cout << "tempList " << tempList.size() << endl;
    
    imageList = tempList;
    
}

int PhotoRecorder::getNumFrames(){
	return imageList.size();
}


int PhotoRecorder::getXpos(){
	return xpos;
}

int PhotoRecorder::getYpos(){
	return ypos;
}

int PhotoRecorder::getCurrentFrame(){
    return currentframe;
}

//--------------------------------------------------------------
void PhotoRecorder::update() {
    
    colorLayer.update();
    
	currentframe++;
    
    if(isRecording){
        //3 cout << "current frame = " << currentframe << endl;
    } else {
        // cout << "current frame = " << currentframe << endl;
        
    }
    
    // take the abs value of the difference between background and incoming and then threshold:
    //grayDiff.absDiff(grayBg, grayImage);
    
    /*
     if((isRecording)&&(currentframe >= max_frames-1)){
     
     isRecording = false;
     } 
     */
    
    if(_alpha != 1){
    //cout << "_alpha = " << _alpha << endl;
    }
    if(getNumFrames() > 10){
        
        // 
        //contourFinder.findContours(grayDiff, 20, 240, 10, true);	// find holes
        
	}
    if(currentframe >= imageList.size())currentframe = 0;
	
    if(currentframe == 0){
        colorItr++;
        if(colorItr > 4){
            colorItr = 0;
        }
        
        float r = ((colors[colorItr] & 0xFF0000) >> 16) / 255.0f;  
        float g = ((colors[colorItr] & 0xFF00) >> 8) / 255.0f;  
        float b = ((colors[colorItr] & 0xFF)) / 255.0f;  
        
        colorLayer.updateColor(r,g,b);
        
    }
    
    Tweenzor::update();
}

/*
 
 ofImage PhotoRecorder::getImage(){
 return imageList[currentframe];
 }
 
 */
//--------------------------------------------------------------
void PhotoRecorder::clear() {
	
	
	//inited = false;
	
	cout << "CLEAR" << getWidth() << " " << getHeight() << endl;
	
    for (int i = 0; i<imageList.size(); i++) {
        //free(imageList[i]);
        
        //delete imageList[i];  
    }
    imageList.resize(0);
    
	//image.setFromPixels(pixels, getWidth(), getHeight(), OF_IMAGE_COLOR);
	
}