/*
 *  photoRecorder.h
 *  _crono3
 *
 *  Created by trollback on 4/12/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#include "ofMain.h"
#include "ofxTweenzor.h"
#include "ofxOpenCv.h"
#include "ColorManager.h"

class PhotoRecorder {
public:	
    
	void drawInfo(ofTrueTypeFont *);  
    void init(int x, int y, int w, int h);
	void setSize(int w, int h);
	void setPosition(int w, int h, bool animate);
    
	int getCurrentFrame();
	
    bool checkIsRecording();
    
	void setFromPixels(unsigned char* _pixels, int w, int h);
	void draw();
	void update();
	void clear();
	
	int getWidth();
	int getHeight();
	
	int getXpos();
	int getYpos();
	
	void setOffset(int n);
	void record();
	void play();
	
	void setColumn(int n);
	void setRow(int n);
    
	int getColumn();
	int getRow();
	
	int column;
	int row;
	
	int width;
	int height;
	float xpos;
	float ypos;
    
	float new_x;
	float new_y;
	
	bool isRecording;
	int currentFrame;
	
	int imageLength;
	
	int currentframe;
	
	int framestep;
	int framerest;
	int framecounter;	
	
	int bufferThreshold;
	
	//vector <ofImage> imageList;
	vector <unsigned char*> imageList;    
	
	ofImage getImage();	
	Tween *tween;
    
    unsigned char* px;
    ofImage img;
    ofImage c_img;
    ofImage b_img;
    
    int max_frames;
    
    void setCurrentFrame(int n);
    void shuffle();
    
    int getNumFrames();
    
	void onCompleteX(float args);
	void onCompleteY(float args);
    
    int colorItr;
    
    void setColorMode(int c);
    float brt;
    float cnt;
    
    float _alpha;
    
    bool showColor;
    
    void traceContours(bool b);
    
    bool doTraceContours;
    
    ColorManager colorLayer;
    //ofxCvContourFinder 	contourFinder;
    //ofxCvGrayscaleImage 	grayDiff;
    int 				threshold;
    
    int colorOffset;
    
    void fadeIn();
    
    int border_width;
    
    ofFbo fbo_a;
    ofFbo fbo_b;
    ofFbo fbo_c;    
    
    
};