#include "testApp.h"



//int colors [] = { 0x00ace6, 0xebad1e, 0xb283b9, 0xba1341 };

//--------------------------------------------------------------
void testApp::setup(){
	
    if( XML.loadFile("_settings.xml") ){
        cout << "loaded" << endl;
        //XML.pushTag("catalog", 0);  
        movieFolderPath = XML.getValue("settings:movieFolder", "data");
        string columns = XML.getValue("settings:columns", "data"); 
        hquads = atoi(columns.c_str());
        string rows = XML.getValue("settings:rows", "data"); 
        vquads = atoi(rows.c_str());
        
    } else {
        cout << "can't load " << endl;
    }
    
    playSpeed = 30;
    recSpeed = 30;
    
	vector <int> moveList;
    
   // colorItr = 0;
    
    cursorPoint.init();
    
    ofEnableSmoothing();
    
    //brt = .55;
    //cnt = .75;
    
    cout << " SETUP " << endl;
    
    prerecordedMovie.loadMovie("vancouver.mp4");
	prerecordedMovie.play();
    prerecordedMovie.setVolume(0);
	ofSetFrameRate(playSpeed);
	//ofScale(2,2);
	// register touch events
	//ofRegisterTouchEvents(this);
    hquads =4;
    vquads = 3;
    ofHideCursor();
    
    grabber.setVerbose(true);
    grabber.initGrabber(ofGetWidth(),ofGetHeight());
    _w = ofGetWidth();
    _h = ofGetHeight();
    quadwidth = ceil(_w / hquads); 
    quadheight = ceil(_h / vquads); 
    
	
    colorImage.allocate(ofGetWidth(),ofGetHeight());
    grayImage.allocate(ofGetWidth(),ofGetHeight());
    grayInit.allocate(ofGetWidth(),ofGetHeight());
    grayBg.allocate(ofGetWidth(),ofGetHeight());

    ofEnableAlphaBlending();
	
	ofSetVerticalSync(true);
	num_frames_export = 300;
	
	ofBackground(0,0,0);
	ofSetBackgroundAuto(true);
    
	//ofToggleFullscreen();
	
    framestep    = 3;
	framerest    = 4;
	framecounter = 0;
	
    angleInDegrees = 0;
	
	videoInited = false;
	
	percentFont.loadFont("akkurat-light-webfont.ttf", 180, true, true, true);
	percentFont.setLineHeight(170.0f);
	//movieMaker = NULL; 
	shouldRecord = false; 	
	isExporting = false;
	isRecording = false;
	
	isLocked = true;
    
	//Our Gui setup
	
	offsetAmount = 20;
	
	displayExports = false;
    
	currentRecording = -1;
    
	isInited = false;
	
	photoMode = 1;
	
	drag_lock = false;
    
    memoryRecorder.init(0, 0, _w, _h);
    
    cropPixels = new unsigned char[_w*_h*3];
    px = new unsigned char[_w*_h*3];
    
	
    updatePositions();
	
	isFullscreenMode = true;
    
    initCount = 0;
    
    isGrabbing = false;
    
    menuThreshold = .05;
    showActivityMeter = false;
    
    doProcessImages = false;
    
    menuIsFaded = true;
    
    currentFrameToProcess = 0;
    
    exportCompleted = false;
    
    menuTimerCount = 0;
    isResting = false;
    
    prevAccelX = 0;
    prevAccelY = 0;
    
    oldSchool = true;
    
    shuffleAmount = 0;
    
    updateShuffle(shuffleAmount);
    shuffleCount = 1;
    positionCount = 0;
    
    
    sTreshold = 0.4;
    trig=0;
    shake=0;
    shakemaxnumber = 1;
    timeofgesture = 1200;
    
    displayInstructions = true;
    
    doExportPhoto = false;
    
	shouldRecord = false; 
    
    mirrorMode = false;
    
    recordingIndividual = false;
	
    prevX = 0;
    prevY = 0;
    
    doDrawCursor = false;
    
    this->copyFilesCounter = new TimedCounter(0,0,5000);//5 seconds
    
    blendMode = 1;
    
    textManager.init();
    
    textManager.addNewItem("JEFF GOODBY");
    textManager.addNewItem("RICK MATHIESON");
    textManager.addNewItem("DEREK HANDLEY");
    textManager.addNewItem("COLIN NAGY");
    
    textManager.addNewItem("JERRY SOLOMON");
    textManager.addNewItem("BILL DUGGAN");
    textManager.addNewItem("MIKE GEIGER");
    textManager.addNewItem("JAMES AKERS");
    
    
    textManager.addNewItem("MICHAL SHAPIRA");
    textManager.addNewItem("DUSTIN CALLIF");
    textManager.addNewItem("DEREK HANDLEY");
    textManager.addNewItem("COLIN NAGY");    
    
    motionTracker.init();
    
	string numberArray[] = {"1", "2", "3", "4", "5", "6", "8", "10", "12", "14", "16", "20"};
	int numberArrayInt[] = {1, 2, 3, 4, 5, 6, 8, 10, 12, 14, 16, 20};
    
    gui.addSlider("brightness", brt, 0.0, 1.0);
    gui.addSlider("contrast", cnt, 0.0, 1.0);
    
    string blArray[] = {"b&w", "color"};
	//gui.addComboBox("color", blendMode, 2,  blArray);
    
	gui.loadFromXML();
    
	gui.show();    
    
    midiOut.listPorts();
    midiOut.openPort(0);
    midiOut.setVerbose(true);
    
    doDisplayGrid = false;
    
    bLearnBakground = false;
    
}


void testApp::updateShuffle(int n){
    
    shuffleAmount = floor(n);
    
    if(shuffleAmount > 0){
        
        int len = 300;
        int mod = floor(len/shuffleAmount)-1;
        
        positionsList.resize(0);
        
        
        for(int i = 0; i<mod; i++){
            positionsList.push_back(i);
            //           cout << " shuffle value " << positionsList[i] << endl;
            
        }
        
        random_shuffle(positionsList.begin(), positionsList.end());
        
        
        
    } else {
        int cur = 0;
        
        for (int i=0; i<buflength; i++){     
            imageList[i].setOffset(cur);
            cur += offsetAmount;//hquads - 1;
        }
    }
}

void testApp::shuffle(){
    
	buflength = hquads * vquads; //plus some extra images
    
    /*
    for (int i=0; i<buflength; i++){	
        cout << "clearing " << i << endl;
        imageList[i].clear();
    }
    */
    
	int xpos; 
	int ypos;
	
	int row = 0;
	int col = 0;
	
	random_shuffle ( imageList.begin(), imageList.end() );
    
	
	for (int i=0; i<buflength; i++){	
		
		xpos = col*quadwidth;
		ypos = row*quadheight;
		
		imageList[i].setPosition(xpos, ypos, false);
		imageList[i].setRow(row);
		imageList[i].setColumn(col);
		
        
		col++;
		if(col == hquads){
			col = 0;
			row++;
		}	
		
	}
    
    
    for(int j=0; j<30; j++){
        midiOut.sendNoteOff(2,24+j*5,127);
    }
	
}

void testApp::initVideo(){
    
	
	if(!videoInited){
		videoInited = true;
		grabber.initGrabber(_w, _h);
	}
}

void testApp::getQuadSubImage(   unsigned char * inputData, unsigned char * outputData,
                              int inW, int inH, int outW, int outH,
                              int x1, int y1, int x2, int y2,
                              int x3, int y3, int x4, int y4, int bpp) {
    
    for(int x=0;x<outW;x++) {
        for(int y=0;y<outH;y++) {
            float xlrp = x/(float)outW;
            float ylrp = y/(float)outH;
            int xinput = (x1*(1-xlrp)+x2*xlrp)*(1-ylrp) + (x4*(1-xlrp)+x3*xlrp)*ylrp;
            int yinput = (y1*(1-ylrp)+y4*ylrp)*(1-xlrp) + (y2*(1-ylrp)+y3*ylrp)*xlrp;
            int inIndex = (xinput + yinput*inW)*bpp;
            int outIndex = (x+y*outW)*bpp;
            memcpy((void*)(outputData+outIndex),(void*)(inputData+inIndex),sizeof(unsigned char)*bpp);
        }
    }
    
}


//--------------------------------------------------------------
void testApp::update(){
    
    prerecordedMovie.idleMovie();
    
    textManager.update();
    
    if(updateInt == 30){
        updateOffsetAmount(offsetAmount * 1.0f);
        updateInt++;
    } else if(updateInt < 30){
        updateInt++;
    }
    
    grabber.grabFrame();
    colorImage.setFromPixels(grabber.getPixels(), _w, _h);

    grayImage = colorImage;

    if (bLearnBakground == true){
        grayBg = grayImage;		// the = sign copys the pixels from grayImage into grayBg (operator overloading)
        bLearnBakground = false;
    }
    
    
    //grayImage.absDiff(grayBg, grayImage);
    
    grayImage.brightnessContrast(brt, cnt);

    
    if(this->copyFilesCounter->isCounting()){
		
		this->copyFilesCounter->update();
        
		if(this->copyFilesCounter->hasChanged()){
            //do copy files

		}
		
	} else {
        
    }
    
    float accTot = accx;
    

    
    if(shuffleAmount > 0){
        
        int mod = 0;//shuffleCount % shuffleAmount;
        
        
        if(mod == 0){
            
            //cout << " mod == 0" << shuffleAmount << endl;
            
            shuffleCount = 1;
            positionCount++;
            if(positionCount > positionsList.size()-1){
                positionCount = 0;
            }    
            
            
            
            //int cur = 0;
            
            for (int i=0; i<buflength; i++){ 
                // cout << " jumping to " << positionsList[positionCount] * shuffleAmount + cur << endl;
                //imageList[i].setCurrentFrame(positionsList[positionCount] * shuffleAmount);
                imageList[i].setOffset(shuffleAmount);
                //cur += offsetAmount;//hquads - 1;
            }
            
        } else {
            shuffleCount++;
        }
        
        
        
    }
	
    
    if(abs(accx - prevAccelX) > .05){
        //cout << "SHAKE!! " << abs(accx - prevAccelX) << endl;
        menuTimerCount = 0;
        
    } else {
        //cout << "NO SHAKE!! " << abs(accx - prevAccelX) << endl;
        menuTimerCount++;
        
    }
    
    prevAccelX = accx;
    prevAccelY = accy;
    
    
    if(showActivityMeter == true){
        menuTimerCount = 0;
        
    } else {
        if((menuIsFaded == true)&&(currentRecording == -1)&&(isRecording == false)&&(isResting == false)){
            
        }
    }
    
    //cout << " ++ update. frame rate =  " << ofGetFrameRate() << endl;
    
	if(initCount < 10){
		initCount++;	
	} else if (initCount == 10){
		initVideo();	
	}
    
    if((isRecording)||(isResting)){
        // myGuiViewController.view.hidden = YES;
        if(menuIsFaded == false){
            
            menuIsFaded = true;
            //menuTimerCount = 0;
            cout << "!!!!!!! FADE MENU " << endl;
            
        }
    } else {
        //myGuiViewController.view.hidden = NO;  
	}
    
    
    
	if(isRecording){
        
        //px = grabber.getPixels();
        
        px = grayImage.getPixels();
        memoryRecorder.setFromPixels(px, _w, _h);
        
        if(!oldSchool){
            
            
            
        } else {
            
            for(int p = 0; p<buflength; p++){
                
                isGrabbing = false;
                unsigned char* cropPixels = new unsigned char[_w*_h*3];
                
                
                //unsigned char* px = grabber.getPixels();
                unsigned char* px = grayImage.getPixels();
                
                
                int Bpp = 1;//this->bpp / 8;
                int x = imageList[p].getXpos();
                int y = imageList[p].getYpos();
                
                int count = 0;
                
                for (int i = x; i < (x+quadwidth) && i < _w; i++){
                    for (int j = y; j < (y+quadheight) && j < _h; j++){
                        for(int b = 0; b < Bpp; b++){
                            cropPixels[((j-y)*quadwidth+(i-x))*Bpp+b] = px[(j*_w+i)*Bpp+b];
                            count++;
                        }
                    }
                }   
                
                imageList[p].setFromPixels(cropPixels, quadwidth, quadheight);	
                
                //delete px;
                delete cropPixels;
                
            }       
            
        }
        
	}
    
    if(!isExporting){
        
        if(isLocked){
            
            if(!isGrabbing){
                
                for(int p = 0; p<buflength; p++){
                    
                    bool rec = imageList[p].isRecording;
                    
                    if(rec){    
                        
                        ///if((currentRecording != -1)){
                        
                        //px = grabber.getPixels();
                        //memoryRecorder.setFromPixels(px, _w, _h);
                        
                        if(menuIsFaded == false){
                            
                            menuIsFaded = true;
                            menuTimerCount = 0;
                            
                        }
                        
                        // myGuiViewController.view.hidden = YES;
                        
                        isGrabbing = false;
                        unsigned char* cropPixels = new unsigned char[_w*_h*3];
                        //unsigned char* px = grabber.getPixels();
                        
                        
                        //unsigned char* px = grabber.getPixels();
                        unsigned char* px = grayImage.getPixels();
                        
                        
                        int Bpp = 1;//this->bpp / 8;
                        int x = imageList[p].getXpos();
                        int y = imageList[p].getYpos();
                        
                        int count = 0;
                        
                        for (int i = x; i < (x+quadwidth) && i < _w; i++){
                            for (int j = y; j < (y+quadheight) && j < _h; j++){
                                for(int b = 0; b < Bpp; b++){
                                    cropPixels[((j-y)*quadwidth+(i-x))*Bpp+b] = px[(j*_w+i)*Bpp+b];
                                    count++;
                                }
                            }
                        }   
                        
                        imageList[p].setFromPixels(cropPixels, quadwidth, quadheight);	
                        
                        //delete px;
                        delete cropPixels;
                        
                    }
                    
                }
                
            } else {
                isGrabbing = false;
            }
            
        }   
        
    }
    
	for (int i=0; i<buflength; i++){
        imageList[i].setColorMode(blendMode);	
        imageList[i].update();	
        
        
        //
        
        unsigned char* px = imageList[i].px;
        int xpos = imageList[i].xpos;
        int ypos = imageList[i].ypos;
        int width = imageList[i].width;
        int height = imageList[i].height;

        //motionTracker.setPixels(px, xpos, ypos, width, height);
       
        if((imageList[i].getCurrentFrame() == 1)){
            triggerNote(i, true);
        } else if((imageList[i].getCurrentFrame() == 5)){
            triggerNote(i, false);    
        } else if(imageList[i].getNumFrames()> 0){
            //cout << "cfr " << imageList[i].currentFrame << endl;
            
        }
	}	
    
    if(menuTimerCount > 90){
        isResting = true;
    } else {
        isResting = false;
    }
    
    
    
    
}

void testApp::triggerNote(int n, Boolean t){
    if(t){
        //cout << "trigger midi" << endl;
        midiOut.sendNoteOn(2,24+n*5,127);
    } else {
       // midiOut.sendNoteOff(2,24+n*5,127);
        
    }
}

bool testApp::getIsExporting(){
	return isExporting;
}

int testApp::getExportPercent(){	
	int pct = (int)(snapCounter/3);
	return pct;
}


void testApp::updateOffsetAmount(float num){
	offsetAmount = floor(num);
	//cout << "offset " << num << endl;
    for (int i=0; i<buflength; i++){
        imageList[i].setCurrentFrame(0);
    }
	updateOffsets();
}


void testApp::updatePlaySpeed(float num){
	playSpeed = int(floor(num));
	ofSetFrameRate(playSpeed);
}

void testApp::updateOffsets(){
	int cur = 0;
	//int col = 0;
	//int row = 0;
	for (int i=0; i<buflength; i++){
        imageList[i].setCurrentFrame(0);
        
		imageList[i].setOffset(cur);
		cur += offsetAmount;//hquads - 1;
		/*
         row++;
         if(row == vquads){
         row = 0;
         col++;
         }
         */
	}
}

int testApp::getRow(int y){
	return max(double(0), min(double(vquads - 1), round(y / (quadheight))));
	
}

int testApp::getColumn(int x){
	return max(double(0), min(double(hquads - 1), round(x / (quadwidth))));
	
}

void testApp::updateGrid(){
	
	
	moveList.resize(0);
    
    int colnew = getColumn(imageList[currentRecording].getXpos());
    
	int rownew = getRow(imageList[currentRecording].getYpos());
    
	//figure out how many rows and columns we've moved
	int hMove = colnew - imageList[currentRecording].getColumn();
	int vMove = rownew - imageList[currentRecording].getRow();
	
    int col = imageList[currentRecording].getColumn();
    int row = imageList[currentRecording].getRow();
    
    
	for(int i = 0; i<imageList.size(); i++){
		
		if(i != currentRecording){
            
			if(hMove < 0){
				
				cout << "hMove " << hMove << endl;
				
                
                cout << "test " << col << " " << imageList[i].getColumn() << " 2nd test = " << (col + hMove) << endl;
                
                
				if(imageList[i].getRow() == row){
                    
					if((imageList[i].getColumn() <= col-1)&&(imageList[i].getColumn() >= (col + hMove))){
                        
						int newCol = imageList[i].getColumn();					
						imageList[i].setColumn(newCol+1);
						cout << "updating column " << newCol << endl;
						moveList.push_back(i);
					} else {
						cout << "fail " << col << " " << imageList[i].getColumn() << " 2nd test = " << (col + hMove) << endl;
					}
					
				}
				
			} else if(hMove > 0){
				
				if(imageList[i].getRow() == row){
					
					//cout << "the test is imageList[i].getColumn() " << imageList[i].getColumn() << " >= "  << (col+1) << " &&  <= imageList[i].getColumn() + hMove " << (imageList[i].getColumn() + hMove) << endl; 
					
					if((imageList[i].getColumn() >= col+1)&&(imageList[i].getColumn() <= col + hMove)){
						
						int newCol = imageList[i].getColumn()-1;					
						imageList[i].setColumn(newCol);
						//cout << "updating column " << col << endl;
						moveList.push_back(i);
					}
					
				}
                
			}
			
			if(vMove < 0){
				
				
				if(imageList[i].getColumn() == col+hMove){
                    
					if((imageList[i].getRow() <= row-1)&&(imageList[i].getRow() >= (row + vMove))){
                        
						int newRow = imageList[i].getRow();					
						imageList[i].setRow(newRow+1);
						moveList.push_back(i);
					}
					
				}
				
			} else if(vMove > 0){
				
				if(imageList[i].getColumn() == col+hMove){
					
					if((imageList[i].getRow() >= row+1)&&(imageList[i].getRow() <= row + vMove)){
						
						int newRow = imageList[i].getRow()-1;					
						imageList[i].setRow(newRow);
						moveList.push_back(i);
                        
					}
					
				}
                
			}            
            
		}
		
		
	}
	
	for (int j = 0;j < moveList.size(); j++)
	{
		cout << "snapp" << moveList[j] << endl;
        
		//push array of items who have move to snap to the grid
		snapToGrid(moveList[j]);
	}	
	
	imageList[currentRecording].setColumn(colnew);
	imageList[currentRecording].setRow(rownew);
    
}

void testApp::snapToGrid(int itemPos)
{
	
	cout << "snapToGrid " << itemPos << endl;
	
	
	int xpos = quadwidth * (imageList[itemPos].getColumn());
	int ypos = quadheight * (imageList[itemPos].getRow());
	imageList[itemPos].setPosition(xpos, ypos, true);
}


//--------------------------------------------------------------
void testApp::draw(){
    
    //cout << " DRAW " << endl;
    
	float scaleh = float(ofGetWidth())/float(_w);
	float scalew = float(ofGetHeight())/float(_h);//1.818181;//
    
	scale = scaleh;
	
	if(scalew > scaleh){
		scale = scalew;
	}
	
    //scale = scale * .25;
    
	float invscale = 1/scale;
    
	ofScale(scale, scale, scale);
	
    ofBackground( 255, 255, 255 );    
	
    newFrame = false;
    
    // single square
    if(doProcessImages){ // processing
        
        cout << "3" << endl;
        
        cout << "process " << endl;
        
        processImages();
        processImages();
        
        for (int i=0; i<buflength; i++){
			
            // cout << " drawing while processing ! " << endl;
            
            imageList[i].draw();
            //imageList[i].update();
            
		}
        
        if(currentFrameToProcess == buflength){
            for (int i=0; i<buflength; i++){
                imageList[i].setCurrentFrame(0);
            }
            updateOffsets();
        }
        //currentRecording = -1;
        
    } else if((isLocked)&&(currentRecording > -1)){
        
        cout << "5" << endl;
        
        if(videoInited){
            if(!isExporting){
                
                // grabber.draw(0,0);	
                //grayImage.draw(0,0);		
                
                
            }
        }
        
        cout << "6" << endl;
        
        for (int i=0; i<buflength; i++){
			
			if(i != currentRecording){
				imageList[i].draw();
				//imageList[i].drawInfo(&FranklinGothic);
			}
            
			//cout << "drawing " << endl;
			
            
		}
		
        for(int p = 0; p<buflength; p++){
            
            bool rec = imageList[p].isRecording;
            
            if(rec){    
                
                //if(currentRecording > -1){
                //if(!isGrabbing){
                
                imageList[p].draw();
                
                //} else {
                //isGrabbing = false;
                //}
                //imageList[currentRecording].drawInfo(&FranklinGothic);
                
            }
            
        }
        
    } else if((!isRecording)){
        
        bool chk = checkExportPhoto();
        
        if(!chk){
            
            if(videoInited){
                
                ofSetColor(255, 255, 255, 255);
                
                if(!isExporting){
                    
                    // grabber.draw(0,0);
                   // grayImage.draw(0,0);		
                    
                    
                }
            }
        }
        
        ofSetColor(255, 255, 255, 255);
        
		for (int i=0; i<buflength; i++){
			
			if(i != currentRecording){
				imageList[i].draw();
			}

            
		}
		
		if(currentRecording > -1){
            
            imageList[currentRecording].draw();
            
		}
		
	} else {
                
        ofSetColor(255, 255, 255, 50);
        
		for (int i=0; i<buflength; i++){
			
			if(i != currentRecording){
				imageList[i].draw();
			}

		}
        
    }
    
    
    if(mirrorMode){
        // ofSetColor(255, 255, 255, 110);    
        //grabber.draw(0,0);	
        //grayImage.draw(0,0);		
        
    }
    
    if(doDisplayGrid){
        drawgrid();
    }
    
    ofSetColor( 255, 255, 255 );
    textManager.draw();
    gui.draw();
    
    if(doDrawCursor==true){
        cursorPoint.setPosition(mouseX/scale, mouseY/scale);
        cursorPoint.draw();
    }
    //
    
}

void testApp::resetStage(){
	
	lock();
    
	//clear all
	int cur = 0;
	for (int i=0; i<buflength; i++){
		imageList[i].clear();
		imageList[i].play();
		cur += 1;
	}
	
    currentRecording = -1;
    
    //memoryRecorder.clear();
    
	updatePositions();
	
}

void testApp::lock(){
	cout << "lock" << endl;
    menuTimerCount = 0;
	isLocked = true;
}

void testApp::unlock(){
    menuTimerCount = 0;
	cout << "unlock" << endl;
	isLocked = false;
}


///////////////////////////////////////////////////////////////
void testApp::drawgrid(){
    
    if(displayInstructions){
        //ofSetColor(40,40,40, 255); 
        ofSetColor(255,226,74, 255); 

    } else {
        ofSetColor(255,226,74, 255); 
    }
    
    if(!blendMode){
        ofSetColor(255,255,255, 255); 

    }
    
  //  ofSetColor(255,255,255, 255); 
    
    //ofSetColor(0,0,0, 255); 

    
    int thick = 1;
    
	//h
	for (int i=1; i<vquads; i++){
		int l = i*quadheight;
		//ofLine(0, l, _w, l);
        ofRect(0, l, _w, thick); 
	}
	ofLine(0, _h, _w, _h); //last line
	
	//v
	for (int i=1; i<hquads; i++){
		int l = i*quadwidth;
		//ofLine(l, 0, l, _h);
        ofRect(l, 0, thick, _h); 
	}
	ofLine(_w, 0, _w, _h); //last line
	
}



void testApp::takePhoto(){
	
	cout << " ++ " << endl;
	//grabber.getPixels();	
    
	isInited = true;
}


void testApp::startRecord(){
	cout << " ++ startRecordstartRecordstartRecordstartRecord ++ " << endl;
    //ofSetFrameRate(recSpeed);
    
   // displayInstructions = false;
	initVideo();
	
	if(isExporting){
        //	stopExport();		
	}
	
	isRecording = true;
    
}

void testApp::processImages(){
	
    showActivityMeter = true;
    
	isRecording = false;
	shouldRecord = false;
    
    int num = memoryRecorder.getNumFrames();
    
    
    if((doProcessImages)&&(currentFrameToProcess < num -2 )){
        
        
        
        for(int z=currentFrameToProcess; z<currentFrameToProcess+1; z++){
            
            px = memoryRecorder.getFrame();
            int Bpp = 3;//this->bpp / 8;
            
            
            if(currentRecording == -1){
                for (int m=0; m<buflength; m++){
                    
                    int x = imageList[m].getXpos();
                    int y = imageList[m].getYpos();
                    
                    for (int i = x; i < (x+quadwidth) && i < _w; i++){
                        for (int j = y; j < (y+quadheight) && j < _h; j++){
                            for(int b = 0; b < Bpp; b++){
                                cropPixels[((j-y)*quadwidth+(i-x))*Bpp+b] = px[(j*_w+i)*Bpp+b];                     
                            }
                        }
                    }               
                    
                    imageList[m].setFromPixels(cropPixels, quadwidth, quadheight);
                    
                }	
            } else {
                
                
                //insert foreach recording
                
                int x = imageList[currentRecording].getXpos();
                int y = imageList[currentRecording].getYpos();
                
                for (int i = x; i < (x+quadwidth) && i < _w; i++){
                    for (int j = y; j < (y+quadheight) && j < _h; j++){
                        for(int b = 0; b < Bpp; b++){
                            cropPixels[((j-y)*quadwidth+(i-x))*Bpp+b] = px[(j*_w+i)*Bpp+b];                     
                        }
                    }
                }               
                
                imageList[currentRecording].setFromPixels(cropPixels, quadwidth, quadheight);
                
            }
            
            memoryRecorder.update();
            
        }
        
        
        currentFrameToProcess++;
    } else {
        for (int m=0; m<buflength; m++){
            imageList[m].setCurrentFrame(0);
        }
        
        updateOffsets();
        
        isRecording = false;
        currentRecording = -1;
        doProcessImages = false;
        memoryRecorder.clear();
        showActivityMeter = false;
        
        
    }
    
    
}
bool testApp::checkExportPhoto(){
    
    return false;
}

void testApp::startExport(){
    
    exportCompleted = false;
	
    ofSetFrameRate(60);
    
	snapCounter = 0;
	isExporting = true;
    
    
    
    if(doExportPhoto){
        // writer.saveScreenshot();
    } else {
        //  writer.startSession();
    }
    
}

void testApp::stopExport(){
	cout << " -- export " << endl;
	cout << " vector size " << exportList.size() << endl;
	snapCounter = 0;
	isExporting = false;
    exportCompleted = true;
    shouldRecord = false;
    if(!doExportPhoto){
        //  writer.endSession();
    }
    ofSetFrameRate(playSpeed);
}

void testApp::cancelRecording(){
    
	isExporting = false;
	snapCounter = 0;
    if(!doExportPhoto){
    }
    shouldRecord = false;
    exportCompleted = false;
    ofSetFrameRate(playSpeed);
    
}


void testApp::incrementH(){
	
	cout << " ++ " << endl;
	hquads++;
    
    if(hquads > ofGetWidth() *.5){
        hquads = ofGetWidth() *.5;
    }
    
    if(ofGetWidth()%hquads != 0){
        incrementH();
        return;
    }
    
    resetStage();
    
    
	quadwidth = ceil(_w / hquads); 
	updatePositions();
	//shouldRecord = true; 
	
}

void testApp::decrementH(){
    
	//cout << " -- " << endl;
	hquads--;
    
    if(hquads < 1)hquads = 1;
    
    if(ofGetWidth()%hquads != 0){
        decrementH();
        return;
    }
	
    resetStage();
    
    
	if(hquads < 1)hquads = 1;
	
	//vquads--;
	quadwidth = ceil(_w / hquads); 
	//quadheight = ofGetHeight() / vquads; 
	
	updatePositions();
	
	
	//saver.finishMovie();
	
	shouldRecord = false; 
}



void testApp::incrementV(){
	
	vquads++;
	
    if(vquads > ofGetHeight() *.5){
        vquads = ofGetHeight() *.5;
    }
	
    
    if(ofGetHeight()%vquads != 0){
        incrementV();
        return;
    }
    
    resetStage();

    quadheight = ceil(_h / vquads); 
	updatePositions();
    
}

void testApp::decrementV(){
    
	
	cout << " -- " << endl;
	vquads--;
	
    
    if(vquads < 1)vquads = 1;
    
    if(ofGetHeight()%vquads != 0){
        decrementV();
        return;
    }
	
	resetStage();
    
	//[settingsView updateRows: vquads];
    
	//vquads--;
	//quadwidth = ofGetWidth() / vquads; 
	quadheight = ceil(_h / vquads); 
	updatePositions();
	
	
	//saver.finishMovie();
	
	//shouldRecord = false; 
}


void testApp::populateFromMemory(){
    
    
    //get number of frames in memory
    
    
    int numMemFrames = memoryRecorder.getNumFrames();
    
    //for each, chop up
    
    cout << "numMemFrames ----- " << numMemFrames << endl;
    
    
    for(int r = 0; r<numMemFrames; r++){    
    
        for(int p = 0; p<buflength; p++){
            
            isGrabbing = false;
            unsigned char* cropPixels = new unsigned char[_w*_h*3];
            
            
            //unsigned char* px = grayImage.getPixels();
            unsigned char* px = memoryRecorder.getFrame(r);
            
            
            int Bpp = 1;//this->bpp / 8;
            int x = imageList[p].getXpos();
            int y = imageList[p].getYpos();
            
            int count = 0;
            
            for (int i = x; i < (x+quadwidth) && i < _w; i++){
                for (int j = y; j < (y+quadheight) && j < _h; j++){
                    for(int b = 0; b < Bpp; b++){
                        cropPixels[((j-y)*quadwidth+(i-x))*Bpp+b] = px[(j*_w+i)*Bpp+b];
                        count++;
                    }
                }
            }   
            
            imageList[p].setFromPixels(cropPixels, quadwidth, quadheight);	
            imageList[p].fadeIn();
            //delete px;
            delete cropPixels;
            
        }
        
    }
}

void testApp::updatePositions(){
    

    
	imageList.resize(0);
	
	quadwidth = ceil(_w / hquads); 
	quadheight = ceil(_h / vquads); 
	
	buflength = hquads * vquads; //plus some extra images
	
	
	int xpos = 0; 
	int ypos = 0;
	
	int row = 0;
	int col = 0;
	
	for (int i=0; i<buflength; i++){	
		
		PhotoRecorder myImage;
		
		xpos = col*quadwidth;
		ypos = row*quadheight;
		
		myImage.init(xpos, ypos, quadwidth, quadheight);
        
		myImage.setRow(row);
		myImage.setColumn(col);
        imageList.push_back(myImage);
		
        col++;
		if(col == hquads){
			col = 0;
			row++;
		}	
	}
    
    row = 0;
	col = 0;
    
    for (int i=0; i<buflength; i++){	
        
		imageList[i].setRow(row);
		imageList[i].setColumn(col);
        
		col++;
		if(col == hquads){
			col = 0;
			row++;
		}	
		
	}
	
}


//--------------------------------------------------------------
void testApp::keyPressed(int key){
	
	cout << "key " << key << endl;
	
    
    
    //
    
    if(key == 'r'){
		//shouldRecord = !shouldRecord; 
	}
    
    if(key == 'm'){
		mirrorMode = !mirrorMode; 
	}
    
    
	switch (key){
        case OF_KEY_UP:
           // displayInstructions = false;
            incrementV();
            updateInt = 0;
            updateOffsets();
			break;   
        case OF_KEY_DOWN:
           // displayInstructions = false;
            decrementV();
            updateInt = 0;
            updateOffsets();
			break; 
        case OF_KEY_RIGHT:
           // displayInstructions = false;
            incrementH();
            updateInt = 0;
            updateOffsets();
			break;   
        case OF_KEY_LEFT:
          //  displayInstructions = false;
            decrementH();
            updateInt = 0;
            updateOffsets();
			break;         
        case 'a':
            isLocked = true;
			isFullscreenMode= true;
			break;              
        case 's':
            isLocked = true;
			isFullscreenMode= false;
			break;     
		case 'd':
            isFullscreenMode= false;
            
			isLocked= false;
			break;            
		case 'f':
            ofToggleFullscreen();
			break;
		case 'q':
            shuffle();
			break;            
            
		case ' ':
            memoryRecorder.clear();
            resetStage();
            videoInited = true;
			break;
        case 'b':
			bLearnBakground = !bLearnBakground;
			break;
        case '`':            
            blendMode = 0;
			break; 
        case '1':
            vquads = 4;
            hquads = 3;
            quadwidth = ceil(_w / hquads); 
            
            quadheight = ceil(_h / vquads); 
            resetStage();
            updatePositions();
            populateFromMemory();
            updateOffsets();
			break; 
        case '2':
            vquads = 1;
            hquads = 8;
            quadwidth = ceil(_w / hquads); 
            
            quadheight = ceil(_h / vquads); 
            resetStage();
            updatePositions();
            populateFromMemory();
            updateOffsets();
			break;   
        case '3':
            vquads = 6;
            hquads = 4;
            quadwidth = ceil(_w / hquads); 
            
            quadheight = ceil(_h / vquads); 
            resetStage();
            updatePositions();
            populateFromMemory();
            updateOffsets();
			break;  
        case '4':
            vquads = 16;
            hquads = 1;
            quadwidth = ceil(_w / hquads); 
            
            quadheight = ceil(_h / vquads); 
            resetStage();
            updatePositions();
            populateFromMemory();
            updateOffsets();
			break;
            
        case '5':
            doDisplayGrid = !doDisplayGrid;
			break;            
            
            
        case 'z':
            displayInstructions = !displayInstructions;
            
            if(displayInstructions){
                gui.show();
            } else {
                gui.hide();
            }
            
			break;   
        case '-':
            brt -= .05;
            if(brt < 0.0)brt = 0.0;
            cout << "brt = " << brt << endl;
            cout << "cnt = " << cnt << endl;

			break; 
            
        case '=':
            brt += .05;
            if(brt > 1.0)brt = 1.0;
            cout << "brt = " << brt << endl;
            cout << "cnt = " << cnt << endl;


			break;  
            
        case '9':
            cnt -= .05;
            if(cnt < 0.0)cnt = 0.0;
            cout << "brt = " << brt << endl;

            cout << "cnt = " << cnt << endl;

			break;
        case ',':
            offsetAmount -= 1;
            if(offsetAmount < 0)offsetAmount = 0;
            updateInt = 0;
            updateOffsets();
			break;
        case '.':
            offsetAmount += 1;
            if(offsetAmount > 60)offsetAmount = 60;
            updateInt = 0;
            updateOffsets();
			break;            
            
        case '0':
            cnt += .05;
            if(cnt > 1.0)cnt = 1.0;
            cout << "brt = " << brt << endl;

            cout << "cnt = " << cnt << endl;

			break;              
            
        case 'c':
            if(blendMode == 1){
                blendMode = 0;
            } else {
                blendMode = 1;
            }
            /*
            colorItr++;
            if(colorItr > 3){
                colorItr = 0;
            }
            
            float r = ((colors[colorItr] & 0xFF0000) >> 16) / 255.0f;  
            float g = ((colors[colorItr] & 0xFF00) >> 8) / 255.0f;  
            float b = ((colors[colorItr] & 0xFF)) / 255.0f;  
            */
           // colorLayer.updateColor(r,g,b);
            
            
            break;
            
	}
}

//--------------------------------------------------------------
void testApp::keyReleased(int key){
	
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
    
    //if((x != prevX)&&(y != prevY)){
    doDrawCursor = true;
    //cout << " DRAW CURSOR " << "prev X = " << prevX << " prev Y = " << prevY << endl;
    //} else {
    
    //cout << " Don't DRAW CURSOR " << endl;
    
    //    doDrawCursor = false;
    //}
    
    
    prevX = x;
    prevY = y;
}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){
    if ((drag_lock)&&(!isLocked)) {
		
        x /=scale;
        y /=scale;
        
		int xnew = x - x_offset_drag;
		int ynew = y - y_offset_drag;
		
		imageList[currentRecording].setPosition(xnew, ynew, false);
		
		updateGrid();
		
    } 
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
    
    cout << "touch down " << x << " " << y << endl;
    
    
    
    if(!videoInited){
        resetStage();
    }
    
    videoInited = true;
    
    x /=scale;
    y /=scale;
    
	int col = floor(x/ quadwidth);
	int row = floor(y/ quadheight);
	
	drag_lock = true;
	
    if(!isFullscreenMode){
        
        for(int i = 0; i<imageList.size(); i++){
            if((imageList[i].getColumn() ==
                col)&&(imageList[i].getRow() == row)){
                currentRecording = i;
                cout << "currentRecording " << i << endl;
            }
        }
        
        x_offset_drag = x- imageList[currentRecording].getXpos();
        y_offset_drag = y - imageList[currentRecording].getYpos(); 
        
    }    else {
        isRecording = true;

    }
    
    initVideo();
    
    if(isLocked){
        if(!isFullscreenMode){
            
            showActivityMeter = false;
            //activityViewController.view.hidden = NO; 
            imageList[currentRecording].clear();
            imageList[currentRecording].record();
            
        } else {
            
            //showActivityMeter = true;
            startRecord();
            
		}
	}
	
	//figure out which quadrant	
	//startRecord();
    
}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){
    //int row = floor(touch.x / quadwidth);
	//int col = floor(touch.y / quadheight);
	
	//cout << "touch up " << row << " " << col << endl;
	
	//int pos = col*vquads + row;
	
    ofSetFrameRate(playSpeed);
    
	if(!isLocked){
		snapToGrid(currentRecording);
	}
    
    drag_lock = false;
    
    //updateOffsets();
    
    isRecording = false;

    
    doExportPhoto = checkExportPhoto();
    
	if(isFullscreenMode){
        
		//memoryRecorder.play();
        
        if(oldSchool){
            
             doProcessImages = false;
             
             isRecording = false;
             currentRecording = -1;
             doProcessImages = false;
            // memoryRecorder.clear();
             showActivityMeter = false;
             
             updateOffsets();
             
        } else {
            
             doProcessImages = true;
             currentFrameToProcess = 0;
             
            // memoryRecorder.play();
             updateOffsets();
            
            //updateOffsets();
            
        }
        
	} else {
        
        doProcessImages = false;
        
        showActivityMeter = false;
        currentRecording = -1;
        
    }
    
    updateOffsets();
    
    for (int m=0; m<buflength; m++){
        imageList[m].play();
    }    
    
    //stopRecord();
    
}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){
	
}


//--------------------------------------------------------------
void testApp::exit(){
	
}

