#ifndef _TEST_APP
#define _TEST_APP

#define APP_WIDTH 1056
#define APP_HEIGHT 704

#include "ofMain.h"
#include "photoRecorder.h"
#include "memoryRecorder.h"

#include <Poco/Mutex.h>
#include <stdio.h>
#include <stdlib.h>

//#include "ofxDirList.h"
#include "photo.h"
#include "ofxSimpleGuiToo.h"
#include "ofxTimer.h"
#include "cursor.h"
//#include "ofxFBOTexture.h"



#include "TextManager.h"
#include "ofxMidiOut.h"

#include "MotionTracker.h"

class testApp : public ofBaseApp{
	
private:
	TimedCounter* counter;	
	TimedCounter* countdownTimer;
	TimedCounter* startUpTimer;
	
public:
	void setup();
	void update();
	void draw();
	
	void keyPressed  (int key);
	void keyReleased(int key);
	void mouseMoved(int x, int y );
	void mouseDragged(int x, int y, int button);
	void mousePressed(int x, int y, int button);
	void mouseReleased(int x, int y, int button);
	void windowResized(int w, int h);
	
	void beginSequence();
	
	void resetStage();
	
	int snapCounter;
    
    
    ofVideoGrabber			grabber; 
    
	void exit();
	
	void updateOffsets();
	
	void lostFocus();
	void gotFocus();
	void takePhoto();
	
	void updatePositions();
	
	void startExport();
	void stopExport();
	
	void startRecord();
	void processImages();
	
	void savePhoto();
	
	void incrementH();
	void decrementH();
    
	void incrementV();
	void decrementV();
	
	void initVideo();
	
	void gotMemoryWarning();
    
	int getRows();
	int getColumns();
	
	bool getIsExporting();
	int getExportPercent();
	
	void drawgrid();
	void drawgridRed();
	void updateOffsetAmount(float num);
	
    void updateShuffle(int n);
    void shuffle();
    void updatePlaySpeed(float num);
	void deviceOrientationChanged(int newOrientation);
    
    void triggerNote(int n, Boolean t);
	
	unsigned char*						pixels;
	int									_w, _h, num_pixels;
	bool								drawInverse;
    
	Photo livePreviewImage;
	unsigned char* stillImagePixels;
	
    ofxCvColorImage     	colorImage;
    ofxCvGrayscaleImage 	grayImage;
    //ofxCvColorImage 	grayImage;
	
    ofTrueTypeFont FranklinGothic;
    
	float sTreshold;
	float accx,accy;
	int trig;
	int startshake;
	int shake;
	int shakemaxnumber;
	int timeofgesture;
	
	float lengthRatio;
	int numPoints;
	bool bFill;
	
	bool doTakePhoto;
	bool doResetStage;
	
	bool isInited;
	
	bool isRecording;
	////
    
    float scale;
	
    int initCount;
    
	int hquads;
	int vquads;
	int quadwidth;
	int quadheight;
	int actualimage;
	int buflength;	
	vector <PhotoRecorder> imageList;
	vector <ofImage> exportList;
	vector <int> moveList;
    vector <int> positionsList;
    
	bool newFrame;
	
	int photoMode;
	
	int framestep;
	int framerest;
	int framecounter;
	
	int currentRecording;
	
	int offsetAmount;
	
	int videoInited;
	
	/* recording variables */
	
	float 	pan;
	int		sampleRate;
	bool 	bNoise;
	float 	volume;
	
	bool shouldRecord; 
	
	bool isExporting;
	
	bool displayExports;
	
	int num_frames_export;
	
	bool drag_lock;
	
	int x_offset_drag;
	int y_offset_drag;
	
	int getRow(int x);
	int getColumn(int y);
	
	void updateGrid();
	void snapToGrid(int num);
	
	void lock();
	void unlock();
	
	bool isLocked;
	
	void cancelRecording();
	
	bool isFullscreenMode;
    
    float menuThreshold;
    
    float prevAccelX;
    float prevAccelY;
    
    bool isGrabbing;
    
    MemoryRecorder memoryRecorder;
    unsigned char* px;
    unsigned char* cropPixels;
    
    bool showActivityMeter;
    bool doProcessImages;
    
    void getQuadSubImage( unsigned char * inputData, unsigned char * outputData,
                         int inW, int inH, int outW, int outH,
                         int x1, int y1, int x2, int y2,
                         int x3, int y3, int x4, int y4, int bpp);
    
    int currentFrameToProcess;
    
    bool menuIsFaded;
    
    bool exportCompleted;
    
    int menuTimerCount;
    bool isResting;
    
    bool oldSchool;
    
    bool checkExportPhoto();
    
    int playSpeed;
    int recSpeed;
    
    int shuffleAmount;
    int shuffleCount;
    int positionCount;
    
    bool displayInstructions;
    bool doExportPhoto;
    
    //int showColor;
    
    void populateFromMemory();
    
    ofImage defaultImage;
    
    int angleInDegrees;	
    
    bool mirrorMode;
    
    bool recordingIndividual;
    
    int prevX;
    int prevY;
    
    bool doDrawCursor;
    
    CursorPoint cursorPoint;
    
    ofImage brandingLogo;
    
    string currentFilename;
    string localBase;
    string remoteBase;
    
    TimedCounter* copyFilesCounter;
    
    ofxXmlSettings XML;
    
    ofTrueTypeFont  percentFont;
    
    string movieFolderPath; 
    
    int blendMode;
    
    int colorItr;
    
    //ColorManager colorLayer;
    TextManager  textManager;
    
    float brt;
    float cnt;
    
    int updateInt;
    
    ofVideoPlayer 		prerecordedMovie;
    
    ofxMidiOut midiOut;
    
    ofxCvGrayscaleImage 	grayBg;
    ofxCvGrayscaleImage 	grayInit;
    
    bool doDisplayGrid;
    bool				bLearnBakground;
    
    MotionTracker motionTracker;
    
};

#endif
